/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Client 饹(Υ饹)Υ饤֥                           */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "ClientP.h"

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

Player ClientGetPlayer(Client client) { return (client->player); }

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Client ClientCreate(char * hostname, unsigned short int port,
		    char * name, int size, int direct_draw,
		    int * argcp, char * argv[])
{
  Client client;
  Path path;
  unsigned short int command;
  unsigned short int length;
  unsigned short int s1;
  unsigned short int s2;
  unsigned short int s3;
  unsigned short int s4;
  unsigned short int s5;

  client = (Client)malloc(sizeof(_Client));
  if (client == NULL) ErrorExit("Cannot allocate memory for client.");

  path = PathCreateToCommunicateWithServer(hostname, port,
					   CLIENT_SEND_BUFFER_SIZE,
					   CLIENT_RECV_BUFFER_SIZE);
  if (path == NULL) {
    printf("If you want to play N.A.D.A.R., You have to start server program\n");
    printf("on a server machine. Run nadar with -help option and see the help.\n");
    ErrorExit("Cannot connect to server.");
  }

  client->player = PlayerCreate(name, path, PLAYER_ACTIVE);
  if (client->player == NULL) ErrorExit("Cannot create my player.");

  /* ɽѤΥǥץ쥤κ */
  /* 饤Ȥ can't open display ȤˡФʤ
     褦ˡФȥͥĥ˥ǥץ쥤򥪡ץ󤹤 */
  client->display = DispCreate(argcp, argv, size, direct_draw);
  if (client->display == NULL) ErrorExit("Cannot create display.");

  /* ФȤΥͥ */
  PathSendStringData(PlayerGetPath(client->player), JOIN_REQUEST,
		     PlayerGetName(client->player));
  PathFlushSendBuffer(PlayerGetPath(client->player));

  while (!PathCheckData(path, &command, &length)) { usleep(10000); }
  if (command == MANY_PLAYERS) {
    PathRecvNoneData(path, &command);
    ErrorExit("Too many players in game. Search other server.");
  }
  if (command != JOIN_ACCEPT) {
    ErrorExit("failed to accept.");
  }
  PathRecvShortShortShortShortShortData(path, &command,
					&s1, &s2, &s3, &s4, &s5);
  if (command != JOIN_ACCEPT) {
    ErrorExit("failed to accept.");
  }

  DispSetParameters(client->display, s1, s2, s3, s4, s5);

  return (client);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Client ClientDestroy(Client client)
{
  if (client == NULL) return (NULL);

  if (client->player) PlayerDestroy(client->player);

  if (client->display) DispDestroy(client->display);

  free(client);

  return (NULL);
}

/*---------------------------------------------------------------------------*/
/* 饤ȤνλȽ                                                    */
/*---------------------------------------------------------------------------*/

#if 0
static int ClientIsOver(Client client)
{
  return (0);
}
#endif

/*---------------------------------------------------------------------------*/
/* 饤ȤΥ                                                    */
/*---------------------------------------------------------------------------*/

static int ClientMain(Client client)
{
  static char buffer[PLAYER_NAME_MAX_LENGTH + 100];
  unsigned short int command;
  unsigned short int length;
  unsigned long int key_press;
  unsigned long int tank_action;
  unsigned char c1, c2;
  unsigned short int s1, s2;
  Path path;

  path = PlayerGetPath(client->player);

  while (1) {

    if (!PathCheckData(path, &command, &length)) {
#if 0
      DispSync(client->display);
#endif
      usleep(10000);
      return (1);
    }

    switch (command) {

    case TANK_DRAW :
      PathRecvCharCharShortShortData(path, &command, &c1, &c2, &s1, &s2);
      DispDrawTank(client->display,
		   (short int)s1 * 0.01, (short int)s2 * 0.01,
		   (signed char)c1, (unsigned char)c2);
      break;

    case CANON_DRAW :
      PathRecvShortShortData(path, &command, &s1, &s2);
      DispDrawCanon(client->display,
		    (short int)s1 * 0.01, (short int)s2 * 0.01);
      break;

    case MISSILE_DRAW :
      PathRecvShortShortData(path, &command, &s1, &s2);
      DispDrawMissile(client->display,
		      (short int)s1 * 0.01, (short int)s2 * 0.01);
      break;

    case EXPLOSION_DRAW :
      PathRecvCharShortShortData(path, &command, &c1, &s1, &s2);
      /*
       * ̿ˡǤοȤǤʤΤǡ
       * οȤꤹ뤿ˡä short int ˥㥹Ȥ
       * (ʤȡ¦Ⱥ¦β̳ȯޤɽʤ)
       */
      DispDrawExplosion(client->display,
			(short int)s1 * 0.01, (short int)s2 * 0.01,
			(unsigned char)c1);
      break;

    case SEND_KEY :
      PathRecvNoneData(path, &command);
      DispSync(client->display);
      key_press = DispGetKeyPress(client->display);
      tank_action = TANK_NO_ACTION;
      if (key_press & DISP_UP_PRESS     ) tank_action |= TANK_GO_FORWARD;
      if (key_press & DISP_DOWN_PRESS   ) tank_action |= TANK_GO_BACKWARD;
      if (key_press & DISP_LEFT_PRESS   ) tank_action |= TANK_TURN_LEFT;
      if (key_press & DISP_RIGHT_PRESS  ) tank_action |= TANK_TURN_RIGHT;
      if (key_press & DISP_BUTTON1_PRESS) tank_action |= TANK_FIRE_MISSILE;
      if (key_press & DISP_BUTTON2_PRESS) tank_action |= TANK_FIRE_CANON;
      if (key_press & DISP_BUTTON4_PRESS) tank_action |= TANK_DEAD;
      PathSendLongData(path, NOW_KEY, tank_action);
      PathFlushSendBuffer(path);
      break;

    case READ_KEY :
      /*
       * ̺̿︺ΤᡤREAD_KEY פˤ뤿ˡSEND_KEY 
       * DispSync() 褦ˤΤǡREAD_KEY פˤʤä
       * ĤƤ
       */
      PathRecvNoneData(path, &command);
      goto loop_exit;
      break;

    case DISPLAY_COPY :
      PathRecvShortShortData(path, &command, &s1, &s2);
      DispDrawDisplay(client->display, s1 * 0.01, s2 * 0.01);
      break;

    case GAME_CLEAN :
      PathRecvNoneData(path, &command);
      DispCleanGamePixmap(client->display);
      break;

    case MAP_DRAW :
      PathRecvCharShortShortData(path, &command, &c1, &s1, &s2);
      DispDrawMap(client->display, s1, s2, c1);
      break;

    case MAP_DRAW2 :
      PathRecvCharCharShortShortData(path, &command, &c1, &c2, &s1, &s2);
      DispDrawMap(client->display, s1, s2, c1);
      DispDrawMap(client->display, s1, s2, c2);
      break;

    case DISPLAY_CLEAR :
      PathRecvNoneData(path, &command);
      DispClearKeyPress(client->display);
      DispClearDisplay(client->display);
      break;

    case TEXT_CLEAR :
      PathRecvNoneData(path, &command);
      DispClearText(client->display);
      break;

    case TEXT_DRAW :
      PathRecvShortStringData(path, &command, &s1, buffer, 300);
      DispDrawText(client->display, s1, buffer);
      break;

    case DELETE_YOU :
      PathRecvNoneData(path, &command);
      fprintf(stderr, "Server down.\n");
      exit (0);
      break;

    case TIMEOUT_YOU :
      /*
       * Ф TIMEOUT_YOU ФΤϡ餫ͳǥ饤ȤǤ
       * ¸ߤƤʤ̿ǽ֤ˤʤäƤȤǤ뤫顤
       * ºݤ TIMEOUT_YOU 뤳ȤϤޤ̵Ȼפ롥
       * äơνŬǤ褤
       */
      PathRecvNoneData(path, &command);
      fprintf(stderr, "Your network is very slow. Timeout.\n");
      exit (0);
      break;

    case DELETE_ME :
      PathRecvNoneData(path, &command);
      break;

    default :
      ErrorExit("Unknown command.");
      break;
    }
  }

loop_exit :

#if 1
#if 0
  DispFlush(client->display);
#else
  DispSync(client->display);
#endif
#endif

  usleep(10000);

  return (0);
}

int ClientStart(Client client)
{
  DispRealize(client->display);
  PathSendNoneData(PlayerGetPath(client->player), ADD_ME);
  PathFlushSendBuffer(PlayerGetPath(client->player));
  DispStart(client->display, ClientMain, client);
  return (0);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
