/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Disp 饹Υ饤֥(Τ)                                     */
/*****************************************************************************/

#ifndef _NADAR_CLIENT_DISPP_H_INCLUDED_
#define _NADAR_CLIENT_DISPP_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "Disp.h"

/* Υԥåޥå */
#include "xpm/icon/icon.xpm"

/* ֤Υԥåޥå */
#include "xpm/tank/tank00.xpm"
#include "xpm/tank/tank01.xpm"
#include "xpm/tank/tank02.xpm"
#include "xpm/tank/tank03.xpm"
#include "xpm/tank/tank04.xpm"
#include "xpm/tank/tank05.xpm"
#include "xpm/tank/tank06.xpm"
#include "xpm/tank/tank07.xpm"
#include "xpm/tank/tank08.xpm"
#include "xpm/tank/tank09.xpm"
#include "xpm/tank/tank10.xpm"
#include "xpm/tank/tank11.xpm"
#include "xpm/tank/tank12.xpm"
#include "xpm/tank/tank13.xpm"
#include "xpm/tank/tank14.xpm"
#include "xpm/tank/tank15.xpm"
#include "xpm/tank/tank16.xpm"
#include "xpm/tank/tank17.xpm"
#include "xpm/tank/tank18.xpm"
#include "xpm/tank/tank19.xpm"
#include "xpm/tank/tank20.xpm"
#include "xpm/tank/tank21.xpm"
#include "xpm/tank/tank22.xpm"
#include "xpm/tank/tank23.xpm"

/* 㳲ʪΥԥåޥå */
#include "xpm/map/none.xpm"
#include "xpm/map/brick1.xpm"
#include "xpm/map/brick2.xpm"
#include "xpm/map/brick3.xpm"
#include "xpm/map/car1.xpm"
#include "xpm/map/car2.xpm"
#include "xpm/map/dram1.xpm"
#include "xpm/map/house1.xpm"
#include "xpm/map/house2.xpm"
#include "xpm/map/house3.xpm"
#include "xpm/map/house4.xpm"
#include "xpm/map/tree1.xpm"
#include "xpm/map/tree2.xpm"
#include "xpm/map/tree3.xpm"
#include "xpm/map/tree4.xpm"
#include "xpm/map/tree5.xpm"

/* ˤƤΥԥåޥå */
#include "xpm/canon/canon.xpm"

/* ߥΥԥåޥå */
#include "xpm/missile/missile.xpm"

/* ȯΥԥåޥå */
#include "xpm/explosion/explosion00.xpm"
#include "xpm/explosion/explosion04.xpm"
#include "xpm/explosion/explosion08.xpm"
#include "xpm/explosion/explosion12.xpm"
#include "xpm/explosion/explosion16.xpm"
#include "xpm/explosion/explosion20.xpm"
#include "xpm/explosion/explosion24.xpm"
#include "xpm/explosion/explosion28.xpm"
#include "xpm/explosion/explosion32.xpm"
#include "xpm/explosion/explosion36.xpm"
#include "xpm/explosion/explosion40.xpm"
#include "xpm/explosion/explosion44.xpm"
#include "xpm/explosion/explosion48.xpm"

static char ** tank_pixmap_name[] = {
  tank00_xpm, tank01_xpm, tank02_xpm, tank03_xpm, tank04_xpm, tank05_xpm,
  tank06_xpm, tank07_xpm, tank08_xpm, tank09_xpm, tank10_xpm, tank11_xpm,
  tank12_xpm, tank13_xpm, tank14_xpm, tank15_xpm, tank16_xpm, tank17_xpm,
  tank18_xpm, tank19_xpm, tank20_xpm, tank21_xpm, tank22_xpm, tank23_xpm
};

static char ** map_pixmap_name[] = {
  none_xpm,
  brick1_xpm, brick2_xpm, brick3_xpm,
  car1_xpm, car2_xpm, dram1_xpm,
  house1_xpm, house2_xpm, house3_xpm, house4_xpm,
  tree1_xpm, tree2_xpm, tree3_xpm, tree4_xpm, tree5_xpm
};

static char ** explosion_pixmap_name[] = {
  explosion00_xpm,
  explosion04_xpm, explosion08_xpm, explosion12_xpm, explosion16_xpm,
  explosion20_xpm, explosion24_xpm, explosion28_xpm, explosion32_xpm,
  explosion36_xpm, explosion40_xpm, explosion44_xpm, explosion48_xpm
};

/* 顼 */
static char * disp_color_name[] = {
  "white"   ,
  "blue"    , "red"     , "green"   , "yellow"  , "purple"  ,
  "pink"    , "magenta" , "orange"  , "cyan"    , "grey"    ,
  "violet"  , "khaki"   , "gold"    , "navy"    , "maroon"  ,
  "sienna"  , "peru"    , "wheat"   , "tan"     , "salmon"  ,
  "beige"   , "coral"   , "tomato"  , "maroon"  , "plum"    ,
  "orchid"  , "thistle"
};

#define DISP_COLOR_NAME_NUMBER ((int)(sizeof(disp_color_name)/sizeof(disp_color_name[0])))

typedef struct _DispChange {
  int x, y;
  int width, height;
  Pixmap pixmap;
  Pixmap mask;
} _DispChange;

typedef struct _DispChange * DispChange; /* Display 饹 */

typedef struct _Disp {
  XtAppContext app_context;
  Widget toplevel;
  Widget canvas;
  Display * display;
  Window top_window;
  Window root_window;
  Colormap colormap;
  unsigned int depth;

  Window game_window, text_window;
  Pixmap game_pixmap, text_pixmap;
  Pixmap icon_pixmap;
  Pixmap icon_mask;

  GC copy_by_copy;
  GC copy_by_and;
  GC copy_by_or;
  GC copy_by_xor;

  GC gc_black;
  GC gc_white;
  GC gc_filled;
  GC gc_none;

  GC gc_color[DISP_COLOR_NAME_NUMBER];

  Client client;

  int (*func)(Client);
  void * proc_data;
  XtIntervalId interval_id;

  Pixmap tank_pixmap[TANK_ANGLE_NUMBER];
  Pixmap map_pixmap[MAP_PIXMAP_NUMBER];
  Pixmap canon_pixmap;
  Pixmap missile_pixmap;
  Pixmap explosion_pixmap[EXPLOSION_NUMBER_NUMBER];
  Pixmap tank_color_mask[DISP_COLOR_NAME_NUMBER];
  Pixmap tank_color_mask_work;

  Font font;
  GC gc_font;

  unsigned long int key_press;

  int map_width, map_height; /* ޥåפ礭(饯ñ) */
  int width, height; /* ̤Υɥ礭(饯ñ) */

  Dimension display_width, display_height;
  Dimension game_window_width, game_window_height;
  Dimension text_window_width, text_window_height;
  Dimension game_pixmap_width, game_pixmap_height;
  Dimension text_pixmap_width, text_pixmap_height;
  int ratio; /* ०ɥΥꤹ롥(̾100) */
  int peeping; /* ԡԥ󥰥⡼ɤɤΥե饰 */
  int direct_draw; /* ľ(®)⡼ɤɤΥե饰 */
  int text_x, text_y;

  ObjList changes;
} _Disp;

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_CLIENT_DISPP_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
