/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

#ifndef _NADAR_CONFIGURE_H_INCLUDED_
#define _NADAR_CONFIGURE_H_INCLUDED_

/*****************************************************************************/
/* Nadar's Version.                                                          */
/*****************************************************************************/

#ifndef VERSION
#define VERSION "Nadar-unknown-version"
#endif

/*****************************************************************************/
/* Definitions of Parameters.                                                */
/*****************************************************************************/

/*===========================================================================*/
/* You can change below parameters as you like.                              */
/*===========================================================================*/

#define PORT 12010

/* Default map size. */
#define MAP_WIDTH  32
#define MAP_HEIGHT 32

/* Default peephole size. */
#define PEEP_MAP_WIDTH  40
#define PEEP_MAP_HEIGHT 40
#define PEEP_WIDTH  17
#define PEEP_HEIGHT 17

/* Specify the default size of display by percent. */
#if 0
#define DISPLAY_DEFAULT_SIZE 100
#else
#define DISPLAY_DEFAULT_SIZE 60
#endif

#define PLAYER_NUMBER_MIN 1 /* Game will start with 1 player. */
#define CANON_NUMBER 3    /* Default number of canon. */
#define MISSILE_NUMBER 3  /* Default number of missiles. */
#define TANK_SPEED 0.3
#define CANON_SPEED 0.8
#define CANON_OFFSET 0.6
#define MISSILE_SPEED 0.8
#define MISSILE_QUICK 0.18
#define MISSILE_OFFSET 0.6
#if 0
#define CANON_INTERVAL 10
#else
#define CANON_INTERVAL 18
#endif
#define MISSILE_INTERVAL 10
#define TANK_DESTROY_INTERVAL 25
#define EXPLOSION_DELAY 5

/* #define MONO_COLOR_TANK */

#define DEFAULT_PEEPHOLE_FLAG 0
#define DEFAULT_BACKWARD_FLAG 1
#define DEFAULT_INTERVAL_TIME 0
#define DEFAULT_TIMEOUT_TIME 5000
#define DEFAULT_MAX_PLAYERS 16

#define DEFAULT_DIRECT_DRAW_FLAG 0

/* TCP_NODELAY ե饰ͭ */
#define SOCKET_TCP_NODELAY_ON

/* /ѥХåեΥ */
#define SERVER_SEND_BUFFER_SIZE 480
#define SERVER_RECV_BUFFER_SIZE 80
#define CLIENT_SEND_BUFFER_SIZE 80
#define CLIENT_RECV_BUFFER_SIZE 480

/*
 * ʲ̵ˤȡԥåޥåפγ̾ˡX ФȤ̤̿
 * 餹ˡä XGetImage() ǥ᡼ƤޤȤƳ/̾
 * Ȥ XPutImage() ǥԥåޥåפ᤹
 * ºݤ˻Ƥߤ顤ʲ̵ˤȻǰʤ30%ۤɵư٤ʤä
 * ޤäƤX Ф X 饤Ȥ̥ޥưƤȤˤϡ
 * ̤̿򸺤餹̤Τǡʲ̵Ȥ롥
 */
#if 0
#define DISP_RESIZE_NOUSE_DST_IMAGE
#endif

/*===========================================================================*/
/* Don't change below parameters.                                            */
/*===========================================================================*/

/* Font size. */
#define FONT_WIDTH   8
#define FONT_HEIGHT 16
#define FONT_OFFSET 14
#define TEXT_WINDOW_WIDTH 20 /* Text window's width is 20 characters. */

#define ICON_SIZE 48      /* Icon size is 48x48. */
#define CHARACTER_SIZE 32 /* The size of map characters is 32x32. */
#define TANK_SIZE 48      /* Tank size is 48x48. */
#define CANON_SIZE 10     /* Canon size is 10x10. */
#define MISSILE_SIZE 10   /* Missile size is 10x10. */
#define EXPLOSION_SIZE 48 /* Explosion size is 48x48. */
#define TANK_ANGLE_NUMBER 24
#define MAP_PIXMAP_NUMBER 16
#define MAP_CITY_MIN 1
#define MAP_CITY_MAX 10
#define MAP_BRICK_MIN 1
#define MAP_BRICK_MAX 3
#define MAP_FOREST_MIN 11
#define MAP_FOREST_MAX 15

#if 1
#define DISPLAY_INTERVAL 25 /* time interval in milliseconds */
#else
#define DISPLAY_INTERVAL 100 /* time interval in milliseconds */
#endif

#define PLAYER_NAME_MAX_LENGTH 32

/* С饤ȴ֤̿ץȥǻѤ륳ޥ */
#define JOIN_REQUEST   0x01 /* StringData(name) */
/* ShortShortShortShortShortData(map_w, map_h, w, h, peeping) */
#define JOIN_ACCEPT    0x02
#define MANY_PLAYERS   0x03 /* NoneData */
#define ADD_ME         0x04 /* NoneData */
#define DELETE_ME      0x05 /* NoneData */
#define DELETE_YOU     0x06 /* NoneData */
#define TIMEOUT_YOU    0x07 /* NoneData */
#define DISPLAY_CLEAR  0x08 /* NoneData */
#define DISPLAY_COPY   0x09 /* ShortShortData(x, y) */
#define SEND_KEY       0x0a /* NoneData */
#define READ_KEY       0x0b /* NoneData */
#define NOW_KEY        0x0c /* LongData(key_state) */
#define MAP_DRAW       0x0d /* ShortShortShortData(x, y, state) */
#define MAP_DRAW2      0x0e /* ShortShortShortShortData(x, y, state1, state2)*/
#define TANK_DRAW      0x0f /* ShortShortShortShortData(x, y, angle, color) */
#define CANON_DRAW     0x10 /* ShortShortData(x, y) */
#define MISSILE_DRAW   0x11 /* ShortShortData(x, y) */
#define EXPLOSION_DRAW 0x12 /* ShortShortShortData(x, y, radius) */
#define GAME_CLEAN     0x13 /* NoneData */
#define TEXT_CLEAR     0x14 /* NoneData */
#define TEXT_DRAW      0x15 /* ShortStringData(color, string) */
/* ShortShortShortShortStringData(state, win, lose, color, name) */
#define PLAYER_DATA    0x16

#endif /* _NADAR_CONFIGURE_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
