.\"
.\" N.A.D.A.R. - A network tank battle game.
.\"
.\" N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.
.\" All Rights Reserved.
.\"
.\" N.A.D.A.R. is a network tank battle game. You get into a tank,
.\" operate it, and destroy other tanks to survive!
.\"
.TH NADAR 1 "March 2001"

.SH NAME

nadar - A client of a network tank battle game N.A.D.A.R. for X.

.SH SYNOPSIS

.B nadar [ options ]

.SH DESCRIPTION

This is a client of N.A.D.A.R. for X.
N.A.D.A.R. is a network tank battle game. You get into a tank,
operate it, and destroy other tanks to survive!

.SH OPTIONS

You can use standard X Toolkit options.

.TP 8
.B -display [displayname]

This option specifies the name of the X server to use.

.TP 8
.B -geometry [+X+Y]

This option specifies the placement of the window on the screen.

.TP 8
.B -name [name]

This option specifies the name of the application.

.TP 8
.B -bg, -background [color]

This option specifies the color of background.

.TP 8
.B -h, -help

Show help messages.

.TP 8
.B -s, -server [server's hostname]

This option specifies the hostname of the N.A.D.A.R.'s server.

.TP 8
.B -p, -player [player's name]

This option specifies the name of the player.

.TP 8
.B -size [display size]

This option specifies the size of the game screen by percent.
Default value is 60.

.TP 8
.B -port

This option specifies the port number of socket. Default port number is 12010.

.TP 8
.B -direct-draw

Fast draw mode. Character pixmaps are copied to the game window directly.
But, characters are flickering in this mode.
This mode is unavailable in peephole game mode.

.TP 8
.B -no-direct-draw

No flickering mode. Character pixmaps are copied to the pixmap temporarily
and the pixmap is copied to the game window. This mode is default.

.PP

.SH "START GAME"

1. N.A.D.A.R. is a client-server model program. You should start
the server program before playing.
Run

.B % nadars

on the server machine.

2. Run some client programs as

.B % nadar -s [Server's hostname] -p [Player's name]

on the some client machines.

3. If playing speed is very slow, Run clients with size option.

.B % nadar -s [Server's hostname] -p [Player's name] -size 30

4. If the performance of client machine is very high, try big size.

.B % nadar -s [Server's hostname] -p [Player's name] -size 120

.SH EXAMPLE

You want to run the server program on "nasu". And you want to play
N.A.D.A.R. on "tomato", "ninjin" and "daikon".

.B nasu> nadars

.B tomato> nadar -s ninjin -p Tanaka
.br
.B ninjin> nadar -s ninjin -p Hashimoto
.br
.B daikon> nadar -s ninjin -p Shida

.SH PLAY

N.A.D.A.R. is a client-server model program.
Start a server program before clients start.
See nadars(1) about server.
.br
Operate your tank and destroy other tanks. You have canon and missiles.
Canon is limitless, but you have only 3 missiles.

.SH KEY OPERATION

.TP 8
.B Up or i

Go forward.

.TP 8
.B Down or k

Go backward.

.TP 8
.B Left or j

Turn left.

.TP 8
.B Right or l

Turn right.

.TP 8
.B x or Left-Alt

Fire the canon.

.TP 8
.B z or Left-Shift

Fire the missile.

.TP 8
.B s or Escape

Destroy.

.TP 8
.B q

Quit.

.SH "SEE ALSO"

X(1), nadars(1)

.SH AUTHOR

Programed by
.B Sakai Hiroaki.
.br
E-Mail : sakai@seki.ee.kagu.sut.ac.jp, hsakai@pfu.co.jp, hsakai@m8.people.or.jp
.br
http://www.seki.ee.kagu.sut.ac.jp/~sakai/myfreesoft/index.html

.SH SPECIAL THANKS

.B Tanaka Makoto
for drawing some pictures, test on FreeBSD, and many advices.
.br
.B Hashimoto Jun
for test on Linux and many advices.
.br
.B Sakai Takeyasu
for some advices.
.br
.B Ooue Shigeo
for some advices.
.br
.B Miyauchi-Seki Lab.'s people
for many advices.
.br
.B Koga Kazuhiro
for test on Linux and some advices.

.SH COPYRIGHT

N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.
.br
All Rights Reserved.
.br
N.A.D.A.R. is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License.
