.\"
.\" N.A.D.A.R. - A network tank battle game.
.\"
.\" N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.
.\" All Rights Reserved.
.\"
.\" N.A.D.A.R. is a network tank battle game. You get into a tank,
.\" operate it, and destroy other tanks to survive!
.\"
.TH NADARS 1 "March 2001"

.SH NAME

nadars - A server of a network tank battle game N.A.D.A.R.

.SH SYNOPSIS

.B nadars [ options ]

.SH DESCRIPTION

This is a server of N.A.D.A.R.
N.A.D.A.R. is a network tank battle game. You get into a tank,
operate it, and destroy other tanks to survive!

.SH OPTIONS

.TP 8
.B -h, -help

Show help messages.

.TP 8
.B -host, -hostname [hostname]

This option specifies the hostname of the N.A.D.A.R.'s server.
If you don't specify the hostname of the server,
Return value from hostname command will be used.

.TP 8
.B -silent

Enter silent mode. The server does not output any messages.

.TP 8
.B -no-silent

Enter non-silent mode. The server output any messages. (Default)

.TP 8
.B -port

This option specifies the port number of socket. Default port number is 12010.

.TP 8
.B -width [width], -height [height]

This option specifies the screen size on peephole mode.
If the server run without peephole mode, these options are no effect.
Default screen size is 17x17.

.TP 8
.B -map-width [width], -map-height [height]

This option specifies the map size.
Default map size is 32x32(non-peephole mode) or 40x40(peephole mode).

.TP 8
.B -peep, -peephole

Enter peephole game mode. Player can see around his tank only.

.TP 8
.B -no-peep, -no-peephole

Enter non-peephole game mode. Player can see the all map. (Default)

.TP 8
.B -backward

Tank can go backward. (Default)

.TP 8
.B -no-backward

Tank cannot go backward.

.TP 8
.B -interval [milli seconds]

Cycle time in playing game.

.TP 8
.B -timeout [milli seconds]

Client timeout in playing game.
If you set timeout short, A client with slow network is rejected.
But, if you open other window of X on client machine in playing game,
N.A.D.A.R. client may be paused and down by timeout.

.TP 8
.B -max-players [number]

Maximum number of players.

.PP

.SH "START GAME"

1. N.A.D.A.R. is a client-server model program. You should start
the server program before playing.
Run

.B % nadars

on the server machine.

2. Run some client programs as

.B % nadar -s [Server's hostname] -p [Player's name]

on the some client machines.

3. If playing speed is very slow, Run clients with size option.

.B % nadar -s [Server's hostname] -p [Player's name] -size 30

4. If you try the peephole mode, run server with peephole option as below.

.B % nadars -peephole

5. If you try the non-backward mode, run server with no-backward option
as below.

.B % nadars -no-backward

.SH EXAMPLE

You want to run the server program on "nasu". And you want to play
N.A.D.A.R. on "tomato", "ninjin" and "daikon".

.B nasu> nadars

.B tomato> nadar -s ninjin -p Tanaka
.br
.B ninjin> nadar -s ninjin -p Hashimoto
.br
.B daikon> nadar -s ninjin -p Shida

.SH PLAY

N.A.D.A.R. is a client-server model program.
Start client programs after a server starts.
See nadar(1) about client.

.SH "SEE ALSO"

X(1), nadar(1)

.SH AUTHOR

Programed by
.B Sakai Hiroaki.
.br
E-Mail : sakai@seki.ee.kagu.sut.ac.jp, hsakai@pfu.co.jp, hsakai@m8.people.or.jp
.br
http://www.seki.ee.kagu.sut.ac.jp/~sakai/myfreesoft/index.html

.SH SPECIAL THANKS

.B Tanaka Makoto
for drawing some pictures, test on FreeBSD, and many advices.
.br
.B Hashimoto Jun
for test on Linux and many advices.
.br
.B Sakai Takeyasu
for some advices.
.br
.B Ooue Shigeo
for some advices.
.br
.B Miyauchi-Seki Lab.'s people
for many and advices.
.br
.B Koga Kazuhiro
for test on Linux and some advices.

.SH COPYRIGHT

N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.
.br
All Rights Reserved.
.br
N.A.D.A.R. is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License.
