/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Explosion 饹(ȯѤΥ饹)Υ饤֥                        */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "ExplosionP.h"

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* ѿμ                                                          */
/*===========================================================================*/

double ExplosionGetX(Explosion explosion) { return (explosion->x); }
double ExplosionGetY(Explosion explosion) { return (explosion->y); }
int ExplosionGetRadius(Explosion explosion)
{ return (counter_to_number[explosion->counter]); }
Tank ExplosionGetTank(Explosion explosion) { return (explosion->tank); }
int ExplosionGetState(Explosion explosion) { return (explosion->state); }

/*===========================================================================*/
/* ȯϰ⤫ɤΥå                                            */
/*===========================================================================*/

int ExplosionCheck(Explosion explosion, double x, double y)
{
  double dx, dy, r;

  dx = x - explosion->x;
  dy = y - explosion->y;
  r = (double)number_to_radius[counter_to_number[explosion->counter]]
    * (1.0 / EXPLOSION_SIZE);

  return (dx * dx + dy * dy <= r * r);
}

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Explosion ExplosionCreate(double x, double y, Tank tank, int state)
{
  Explosion explosion;

  explosion = (Explosion)malloc(sizeof(_Explosion));
  if (explosion == NULL) ErrorExit("Cannot create canon.");

  explosion->x = x;
  explosion->y = y;
  explosion->tank = tank;
  explosion->state = state;
  explosion->counter = 0;

  return (explosion);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Explosion ExplosionDestroy(Explosion explosion)
{
  if (explosion == NULL) return (NULL);

  free(explosion);

  return (NULL);
}

/*===========================================================================*/
/* ȯ                                                                      */
/*===========================================================================*/

int ExplosionAct(Explosion explosion, Map map)
{
  switch (explosion->state) {
  case EXPLOSION_WAIT :
    break;
  case EXPLOSION_ACTIVE :
    (explosion->counter)++;

    /*
     * ޥåץǡι
     * Υ塼˥󥰤κݤˡΥߥ󥰤ͳӤΤǡ
     *  explosion->counter 򸫤ƽ褦ˤ롥
     */
    if (explosion->counter == EXPLOSION_DELAY) {
      MapChangeState(map,
		     ConvertXFromPositionToMap(explosion->x),
		     ConvertYFromPositionToMap(explosion->y), 0);
    }

    if (explosion->counter >= EXPLOSION_COUNTER_NUMBER)
      explosion->state = EXPLOSION_DESTROY;
    break;
  case EXPLOSION_DESTROY :
    break;
  }
  return (explosion->state);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
