/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Explosion 饹(ȯѤΥ饹)Υ饤֥()                */
/*****************************************************************************/

#ifndef _NADAR_SHARE_EXPLOSION_H_INCLUDED_
#define _NADAR_SHARE_EXPLOSION_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Explosion * Explosion; /* Explosion 饹 */

#include "configure.h"

#include "etc.h"
#include "Obj.h"
#include "Map.h"
#include "Tank.h"

#define EXPLOSION_WAIT      0
#define EXPLOSION_ACTIVE    1
#define EXPLOSION_DESTROY   2

#define EXPLOSION_NUMBER_NUMBER 13

/*===========================================================================*/
/* ѿμ                                                          */
/*===========================================================================*/

double ExplosionGetX(Explosion explosion);
double ExplosionGetY(Explosion explosion);
int ExplosionGetRadius(Explosion explosion);
Tank ExplosionGetTank(Explosion explosion);
int ExplosionGetState(Explosion explosion);

/*===========================================================================*/
/* ȯϰ⤫ɤΥå                                            */
/*===========================================================================*/

int ExplosionCheck(Explosion explosion, double x, double y);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Explosion ExplosionCreate(double x, double y, Tank tank, int state);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Explosion ExplosionDestroy(Explosion explosion);

/*===========================================================================*/
/* ȯ                                                                      */
/*===========================================================================*/

int ExplosionAct(Explosion explosion, Map map);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_EXPLOSION_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
