/*****************************************************************************/
/* Path.h - A library for network communication.                             */
/*                                                                           */
/* Path.h Copyright (c) 2000-2001 Sakai Hiroaki.                             */
/* All Rights Reserved.                                                      */
/*****************************************************************************/

/*****************************************************************************/
/* Path 饹(̿ϩΥ饹)                                               */
/* ()                                                            */
/*===========================================================================*/
/* Υե                                                        */
/*---------------------------------------------------------------------------*/
/* Υեϡ󥯥롼ѤΥإåեǤ                  */
/* Path 饹ȤˤϡΥե򥤥󥯥롼ɤƤ           */
/*===========================================================================*/
/*                                                                       */
/*---------------------------------------------------------------------------*/
/* Фȥ饤ȴ֤Ǥ̿ϩδѤΥ饹Ǥ                    */
/* եǥץδ򤷤ޤ                                    */
/*****************************************************************************/

#ifndef _SAKAILIB_PATH_H_INCLUDED_
#define _SAKAILIB_PATH_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

/*****************************************************************************/
/* إåեΥ󥯥롼                                              */
/*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>    /* select() ɬ */
#include <sys/types.h> /* select() ɬ */
#include <sys/time.h>  /* select() ɬ */

#include "configure.h"

/*****************************************************************************/
/* (˸)                                            */
/*****************************************************************************/

/* None */

/*****************************************************************************/
/* (˸)                                              */
/*****************************************************************************/

typedef struct _Path * Path; /* Path 饹 */

/*****************************************************************************/
/* ¤Τ(˸)                                          */
/*****************************************************************************/

/* None */

/*****************************************************************************/
/* ѿ(˸)                                        */
/*****************************************************************************/

/* None */

/*****************************************************************************/
/* ᥽åɤ(˸)                                        */
/*****************************************************************************/

/*===========================================================================*/
/* ե饰λѤΥ᥽åɤ                                            */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ̿ϩ³                                                          */
/*---------------------------------------------------------------------------*/

int PathIsConnected(Path p);
int PathIsDisconnected(Path p);

/*===========================================================================*/
/* ֥Ȥ                                                        */
/*===========================================================================*/

Path PathCreateToAcceptRequestsFromClients(char * hostname,
					   unsigned short int port,
					   int backlog);
Path PathCreateToCommunicateWithClient(Path path,
				       int send_buffer_size,
				       int recv_buffer_size);
Path PathCreateToCommunicateWithServer(char * hostname,
				       unsigned short int port,
				       int send_buffer_size,
				       int recv_buffer_size);

/*===========================================================================*/
/* ֥Ȥξõ                                                        */
/*===========================================================================*/

Path PathDestroy(Path path);

/*===========================================================================*/
/* ǡΥ᥽åɤ                                              */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ХåեΥեå                                                  */
/*---------------------------------------------------------------------------*/

int PathFlushSendBuffer(Path p);

/*---------------------------------------------------------------------------*/
/* ʤǡ(type )                                   */
/*---------------------------------------------------------------------------*/

int PathSendNoneData(Path p, unsigned short int type);

/*---------------------------------------------------------------------------*/
/* short Υǡ                                                      */
/*---------------------------------------------------------------------------*/

int PathSendShortData(Path p, unsigned short int type,
		      unsigned short int s1);

/*---------------------------------------------------------------------------*/
/* short, short Υǡ                                               */
/*---------------------------------------------------------------------------*/

int PathSendShortShortData(Path p, unsigned short int type,
			   unsigned short int s1,
			   unsigned short int s2);

/*---------------------------------------------------------------------------*/
/* short, short, short Υǡ                                        */
/*---------------------------------------------------------------------------*/

int PathSendShortShortShortData(Path p, unsigned short int type,
				unsigned short int s1,
				unsigned short int s2,
				unsigned short int s3);

/*---------------------------------------------------------------------------*/
/* short, short, short, short Υǡ                                 */
/*---------------------------------------------------------------------------*/

int PathSendShortShortShortShortData(Path p, unsigned short int type,
				     unsigned short int s1,
				     unsigned short int s2,
				     unsigned short int s3,
				     unsigned short int s4);

/*---------------------------------------------------------------------------*/
/* short, short, short, short, short Υǡ                          */
/*---------------------------------------------------------------------------*/

int PathSendShortShortShortShortShortData(Path p, unsigned short int type,
					  unsigned short int s1,
					  unsigned short int s2,
					  unsigned short int s3,
					  unsigned short int s4,
					  unsigned short int s5);

/*---------------------------------------------------------------------------*/
/* long Υǡ                                                       */
/*---------------------------------------------------------------------------*/

int PathSendLongData(Path p, unsigned short int type,
		     unsigned long int s1);

/*---------------------------------------------------------------------------*/
/* long, long Υǡ                                                 */
/*---------------------------------------------------------------------------*/

int PathSendLongLongData(Path p, unsigned short int type,
			 unsigned long int s1,
			 unsigned long int s2);

/*---------------------------------------------------------------------------*/
/* char, char, char, char Υǡ                                     */
/*---------------------------------------------------------------------------*/

int PathSendCharCharCharCharData(Path p, unsigned short int type,
				 unsigned char c1, unsigned char c2,
				 unsigned char c3, unsigned char c4);

/*---------------------------------------------------------------------------*/
/* char, char, short, short Υǡ                                   */
/*---------------------------------------------------------------------------*/

int PathSendCharCharShortShortData(Path p, unsigned short int type,
				   unsigned char c1,
				   unsigned char c2,
				   unsigned short int s1,
				   unsigned short int s2);

/*---------------------------------------------------------------------------*/
/* char, short, short Υǡ                                         */
/*---------------------------------------------------------------------------*/

int PathSendCharShortShortData(Path p, unsigned short int type,
			       unsigned char c1,
			       unsigned short int s1,
			       unsigned short int s2);

/*---------------------------------------------------------------------------*/
/* ʸǡ                                                        */
/*---------------------------------------------------------------------------*/

int PathSendStringData(Path p, unsigned short int type, char * string);

/*---------------------------------------------------------------------------*/
/* short, string Υǡ                                              */
/*---------------------------------------------------------------------------*/

int PathSendShortStringData(Path p, unsigned short int type,
			    unsigned short int s1,
			    char * string);

/*---------------------------------------------------------------------------*/
/* char, char, short, short, string Υǡ                           */
/*---------------------------------------------------------------------------*/

int PathSendCharCharShortShortStringData(Path p, unsigned short int type,
					 unsigned char c1,
					 unsigned char c2,
					 unsigned short int s1,
					 unsigned short int s2,
					 char * string);

/*---------------------------------------------------------------------------*/
/* short, short, short, short, string Υǡ                         */
/*---------------------------------------------------------------------------*/

int PathSendShortShortShortShortStringData(Path p, unsigned short int type,
					   unsigned short int s1,
					   unsigned short int s2,
					   unsigned short int s3,
					   unsigned short int s4,
					   char * string);

/*===========================================================================*/
/* ǡμΥ᥽åɤ                                              */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ѥξ֤Ĵ٤ʤ                                                */
/*---------------------------------------------------------------------------*/

/*
 * ѥ select() ơǡƤʤɤĴ٤롥
 * ǡƤ 1 ֤ǡ̵ä 0 ֤
 */

int PathCheckRecvState(Path p);

/*---------------------------------------------------------------------------*/
/* ե졼Υإå                                                    */
/*---------------------------------------------------------------------------*/

/*
 * Хåեɤ߹ǡ뤫ɤĴ٤롥
 * ɤ߹߲ǽʥǡ¸ߤϡtype  length ͤꤷ
 * 1 ̵֤ˤϡselect() Ǽǡ̵ɤưĴ١
 * Ǥ̵ 0 ֤
 */
int PathCheckData(Path p,
		  unsigned short int * type,
		  unsigned short int * length);

/*---------------------------------------------------------------------------*/
/* ե졼̵뤹롥(Υե졼˥å)                              */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathDiscardData(Path p, unsigned short int * type);

/*---------------------------------------------------------------------------*/
/* ʤǡ(type Τ߼)                                 */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvNoneData(Path p, unsigned short int * type);

/*---------------------------------------------------------------------------*/
/* short Υǡ                                                      */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvShortData(Path p, unsigned short int * type,
		      unsigned short int * s1);

/*---------------------------------------------------------------------------*/
/* short, short Υǡ                                               */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvShortShortData(Path p, unsigned short int * type,
			   unsigned short int * s1,
			   unsigned short int * s2);

/*---------------------------------------------------------------------------*/
/* short, short, short Υǡ                                        */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvShortShortShortData(Path p, unsigned short int * type,
				unsigned short int * s1,
				unsigned short int * s2,
				unsigned short int * s3);

/*---------------------------------------------------------------------------*/
/* short, short, short, short Υǡ                                 */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvShortShortShortShortData(Path p, unsigned short int * type,
				     unsigned short int * s1,
				     unsigned short int * s2,
				     unsigned short int * s3,
				     unsigned short int * s4);

/*---------------------------------------------------------------------------*/
/* short, short, short, short, short Υǡ                          */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvShortShortShortShortShortData(Path p, unsigned short int * type,
					  unsigned short int * s1,
					  unsigned short int * s2,
					  unsigned short int * s3,
					  unsigned short int * s4,
					  unsigned short int * s5);

/*---------------------------------------------------------------------------*/
/* long Υǡ                                                       */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvLongData(Path p, unsigned short int * type,
		     unsigned long int * s1);

/*---------------------------------------------------------------------------*/
/* long, long Υǡ                                                 */
/*---------------------------------------------------------------------------*/

/* ǡ̵ˤϡ0 ֤ */

int PathRecvLongLongData(Path p, unsigned short int * type,
			 unsigned long int * s1,
			 unsigned long int * s2);

/*---------------------------------------------------------------------------*/
/* char, char, char, char Υǡ                                     */
/*---------------------------------------------------------------------------*/

int PathRecvCharCharCharCharData(Path p, unsigned short int * type,
				 unsigned char * c1, unsigned char * c2,
				 unsigned char * c3, unsigned char * c4);

/*---------------------------------------------------------------------------*/
/* char, char, short, short Υǡ                                   */
/*---------------------------------------------------------------------------*/

int PathRecvCharCharShortShortData(Path p, unsigned short int * type,
				   unsigned char * c1,
				   unsigned char * c2,
				   unsigned short int * s1,
				   unsigned short int * s2);

/*---------------------------------------------------------------------------*/
/* char, short, short Υǡ                                         */
/*---------------------------------------------------------------------------*/

int PathRecvCharShortShortData(Path p, unsigned short int * type,
			       unsigned char * c1,
			       unsigned short int * s1,
			       unsigned short int * s2);

/*---------------------------------------------------------------------------*/
/* ʸ                                                              */
/*---------------------------------------------------------------------------*/

int PathRecvStringData(Path p, unsigned short int * type,
		       unsigned char * string, int size);

/*---------------------------------------------------------------------------*/
/* short, string Υǡ                                              */
/*---------------------------------------------------------------------------*/

int PathRecvShortStringData(Path p, unsigned short int * type,
			    unsigned short int * s1,
			    unsigned char * string,
			    int size);

/*---------------------------------------------------------------------------*/
/* char, char, short, short, string Υǡ                           */
/*---------------------------------------------------------------------------*/

int PathRecvCharCharShortShortStringData(Path p, unsigned short int * type,
					 unsigned char * c1,
					 unsigned char * c2,
					 unsigned short int * s1,
					 unsigned short int * s2,
					 unsigned char * string,
					 int size);

/*---------------------------------------------------------------------------*/
/* short, short, short, short, string Υǡ                         */
/*---------------------------------------------------------------------------*/

int PathRecvShortShortShortShortStringData(Path p, unsigned short int * type,
					   unsigned short int * s1,
					   unsigned short int * s2,
					   unsigned short int * s3,
					   unsigned short int * s4,
					   unsigned char * string,
					   int size);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
