/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Player 饹(ץ쥤䡼Υ饹)Υ饤֥()               */
/*****************************************************************************/

#ifndef _NADAR_SHARE_PLAYER_H_INCLUDED_
#define _NADAR_SHARE_PLAYER_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Player * Player; /* Player 饹 */

#include "configure.h"

#include "etc.h"
#include "Obj.h"
#include "Path.h"
#include "Map.h"
#include "Tank.h"
#include "Canon.h"
#include "Missile.h"
#include "Explosion.h"

/*
 * ץ쥤䡼ξ
 * 
 * PLAYER_WAIT
 * Ф³ƻ׵ФƼդ줿
 * 饤¦ǲ̤νäƤʤΤǡ˻äƤʤ
 * (ξ硤ǡϹԤʤADD_ME ׵ԤǡPLAYER_ACTIVE 
 *  ܹԤ)
 * 
 * PLAYER_ACTIVE
 * ˻äƤ
 *
 * PLAYER_DONE
 * ˻äƤơǡ֡(Ϥμ˻)
 *
 * PLAYER_DESTROY
 * फȴ褦ȤƤ
 */
#define PLAYER_WAIT    0
#define PLAYER_ACTIVE  1
#define PLAYER_DONE    2
#define PLAYER_DESTROY 3

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

int PlayerGetState(Player p);
int PlayerSetState(Player p, int state);
Path PlayerGetPath(Player p);
Path PlayerSetPath(Player p, Path path);
Tank PlayerGetTank(Player p);
Tank PlayerSetTank(Player p, Tank tank);
char * PlayerGetName(Player p);
int PlayerGetColorNumber(Player p);
unsigned long int PlayerGetJoinTime(Player p);

int PlayerGetWin( Player p);
int PlayerIncWin( Player p);
int PlayerGetLose(Player p);
int PlayerIncLose(Player p);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Player PlayerCreate(char * name, Path path, int state);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Player PlayerDestroy(Player player);

/*===========================================================================*/
/* ǡ                                                            */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ǡɤ߹                                                      */
/*---------------------------------------------------------------------------*/

char * PlayerReadData(Player player, char * p);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_PLAYER_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
