/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* ¾δؿΥ饤֥                                                  */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "etc.h"

/*---------------------------------------------------------------------------*/
/* 顼ǽλ                                                              */
/*---------------------------------------------------------------------------*/

void ErrorExit(char * s)
{
  fprintf(stderr, "Error : %s\n", s);
  exit (1);
}

/*---------------------------------------------------------------------------*/
/* ν                                                              */
/*---------------------------------------------------------------------------*/

void InitializeRandom()
{
  time_t t;

  time(&t);
  srand(t);
}

/*---------------------------------------------------------------------------*/
/* μ                                                                */
/*---------------------------------------------------------------------------*/

int GetRandomValue(int n)
{
  return ((rand() / 4) % n);
}

/*---------------------------------------------------------------------------*/
/* ߻                                                            */
/*---------------------------------------------------------------------------*/

unsigned long int GetNowTime()
{
  time_t t;
  time(&t);
  return (t);
}

/*---------------------------------------------------------------------------*/
/* ߥñ̤Ǽ(256000ߥ(256)Ȥ0)                  */
/*---------------------------------------------------------------------------*/

long int GetTimeForMilliSeconds()
{
  long int ret;
  struct timeval tm;
  struct timezone tz;

  gettimeofday(&tm, &tz);

  ret = (long int)(((unsigned long int)tm.tv_sec) & 0xff) * 1000
    + tm.tv_usec / 1000;

  return (ret);
}

/*---------------------------------------------------------------------------*/
/* ɸѴ                                                                */
/*---------------------------------------------------------------------------*/

int ConvertXFromPositionToMap(double x) { return ((int)(x + 5) - 5); }
int ConvertYFromPositionToMap(double y) { return ((int)(y + 5) - 5); }

int ConvertXFromPositionToDisplay(double x, int ratio)
{ return (((int)(x * CHARACTER_SIZE + 5.5) - 5) * ratio / 100); }
int ConvertYFromPositionToDisplay(double y, int ratio)
{ return (((int)(y * CHARACTER_SIZE + 5.5) - 5) * ratio / 100); }

int ConvertXFromMapToDisplay(double x, int ratio)
{ return (x * CHARACTER_SIZE * ratio / 100); }
int ConvertYFromMapToDisplay(double y, int ratio)
{ return (y * CHARACTER_SIZE * ratio / 100); }

/*---------------------------------------------------------------------------*/
/* κ                                                                */
/*---------------------------------------------------------------------------*/

int DeleteArgument(int * argcp, char * argv[], int n)
{
  if (n < 1 || n > *argcp - 1) return (1);

  for (; n < *argcp - 1; n++) {
    argv[n] = argv[n + 1];
  }
  argv[n] = NULL;
  (*argcp)--;

  return (0);
}

/*===========================================================================*/
/* μ                                                                */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ʸȤƼ                                                          */
/*---------------------------------------------------------------------------*/

char * GetArgument(int * argcp, char * argv[], char * arg)
{
  int i;
  char * p = NULL;

  for (i = 1; i < *argcp; i++) {
    if (!strcmp(argv[i], arg)) {
      DeleteArgument(argcp, argv, i);
      if (i < *argcp) {
	p = argv[i];
	DeleteArgument(argcp, argv, i);
      }
      i--;
    }
  }
  return (p);
}

/*---------------------------------------------------------------------------*/
/* ͤȤƼ                                                          */
/*---------------------------------------------------------------------------*/

int GetArgumentByIntegerValue(int * argcp, char * argv[], char * arg)
{
  char * p;

  p = GetArgument(argcp, argv, arg);
  if (p == NULL) return (-1);

  return (atoi(p));
}

/*---------------------------------------------------------------------------*/
/* ֡ꥢͤȤƼ                                                    */
/*---------------------------------------------------------------------------*/

int GetArgumentByBoolean(int * argcp, char * argv[], char * arg)
{
  int i;
  int ret = 0;

  for (i = 1; i < *argcp; i++) {
    if (!strcmp(argv[i], arg)) {
      DeleteArgument(argcp, argv, i);
      ret = 1;
    }
  }
  return (ret);
}

/*===========================================================================*/
/* ʰ sqrt() ؿ                                                          */
/*===========================================================================*/

static double sqrt_value[] = {
   0.0000000000,  1.0000000000,  1.4142135624,  1.7320508076,  2.0000000000,
   2.2360679775,  2.4494897428,  2.6457513111,  2.8284271247,  3.0000000000,
   3.1622776602,  3.3166247904,  3.4641016151,  3.6055512755,  3.7416573868,
   3.8729833462,  4.0000000000,  4.1231056256,  4.2426406871,  4.3588989435,
   4.4721359550,  4.5825756950,  4.6904157598,  4.7958315233,  4.8989794856,
   5.0000000000,  5.0990195136,  5.1961524227,  5.2915026221,  5.3851648071,
   5.4772255751,  5.5677643628,  5.6568542495,  5.7445626465,  5.8309518948,
   5.9160797831,  6.0000000000,  6.0827625303,  6.1644140030,  6.2449979984,
   6.3245553203,  6.4031242374,  6.4807406984,  6.5574385243,  6.6332495807,
   6.7082039325,  6.7823299831,  6.8556546004,  6.9282032303,  7.0000000000,
   7.0710678119,  7.1414284285,  7.2111025509,  7.2801098893,  7.3484692283,
   7.4161984871,  7.4833147735,  7.5498344353,  7.6157731059,  7.6811457479,
   7.7459666924,  7.8102496759,  7.8740078740,  7.9372539332,  8.0000000000,
   8.0622577483,  8.1240384046,  8.1853527719,  8.2462112512,  8.3066238629,
   8.3666002653,  8.4261497732,  8.4852813742,  8.5440037453,  8.6023252670,
   8.6602540378,  8.7177978871,  8.7749643874,  8.8317608663,  8.8881944173,
   8.9442719100,  9.0000000000,  9.0553851381,  9.1104335791,  9.1651513899,
   9.2195444573,  9.2736184955,  9.3273790531,  9.3808315196,  9.4339811321,
   9.4868329805,  9.5393920142,  9.5916630466,  9.6436507610,  9.6953597148,
   9.7467943448,  9.7979589711,  9.8488578018,  9.8994949366,  9.9498743711,
  10.0000000000, 10.0498756211, 10.0995049384, 10.1488915651, 10.1980390272,
  10.2469507660, 10.2956301410, 10.3440804328, 10.3923048454, 10.4403065089,
  10.4880884817, 10.5356537529, 10.5830052443, 10.6301458127, 10.6770782520,
  10.7238052948, 10.7703296143, 10.8166538264, 10.8627804912, 10.9087121146,
  10.9544511501, 11.0000000000, 11.0453610172, 11.0905365064, 11.1355287257,
  11.1803398875, 11.2249721603, 11.2694276696, 11.3137084990, 11.3578166916,
  11.4017542510, 11.4455231423, 11.4891252931, 11.5325625947, 11.5758369028,
  11.6189500386, 11.6619037897, 11.7046999107, 11.7473401245, 11.7898261226,
  11.8321595662, 11.8743420870, 11.9163752878, 11.9582607431, 12.0000000000,
  12.0415945788, 12.0830459736, 12.1243556530, 12.1655250606, 12.2065556157,
  12.2474487139, 12.2882057274, 12.3288280059, 12.3693168769, 12.4096736460,
  12.4498995980, 12.4899959968, 12.5299640861, 12.5698050900, 12.6095202129,
  12.6491106407, 12.6885775404, 12.7279220614, 12.7671453348, 12.8062484749,
  12.8452325787, 12.8840987267, 12.9228479833, 12.9614813968, 13.0000000000,
  13.0384048104, 13.0766968306, 13.1148770486, 13.1529464380, 13.1909059583,
  13.2287565553, 13.2664991614, 13.3041346957, 13.3416640641, 13.3790881603,
  13.4164078650, 13.4536240471, 13.4907375632, 13.5277492585, 13.5646599663,
  13.6014705087, 13.6381816970, 13.6747943312, 13.7113092008, 13.7477270849,
  13.7840487521, 13.8202749611, 13.8564064606, 13.8924439894, 13.9283882772,
  13.9642400438, 14.0000000000, 14.0356688476, 14.0712472795, 14.1067359797,
  14.1421356237, 14.1774468788, 14.2126704036, 14.2478068488, 14.2828568571,
  14.3178210633, 14.3527000944, 14.3874945699, 14.4222051019, 14.4568322948,
  14.4913767462, 14.5258390463, 14.5602197786, 14.5945195193, 14.6287388383,
  14.6628782986, 14.6969384567, 14.7309198627, 14.7648230602, 14.7986485869,
  14.8323969742, 14.8660687473, 14.8996644258, 14.9331845231, 14.9666295471,
  15.0000000000, 15.0332963784, 15.0665191733, 15.0996688705, 15.1327459504,
  15.1657508881, 15.1986841536, 15.2315462117, 15.2643375225, 15.2970585408,
  15.3297097168, 15.3622914957, 15.3948043183, 15.4272486205, 15.4596248337,
  15.4919333848, 15.5241746963, 15.5563491861, 15.5884572681, 15.6204993518,
  15.6524758425, 15.6843871414, 15.7162336455, 15.7480157480, 15.7797338381,
  15.8113883008, 15.8429795178, 15.8745078664, 15.9059737206, 15.9373774505,
  15.9687194227, 16.0000000000, 16.0312195419, 16.0623784042, 16.0934769394,
  16.1245154966, 16.1554944214, 16.1864140562, 16.2172747402, 16.2480768093,
  16.2788205961, 16.3095064303, 16.3401346384, 16.3707055437, 16.4012194669,
  16.4316767252, 16.4620776332, 16.4924225025, 16.5227116419, 16.5529453572,
  16.5831239518, 16.6132477258, 16.6433169771, 16.6733320005, 16.7032930885,
  16.7332005307, 16.7630546142, 16.7928556237, 16.8226038413, 16.8522995464,
  16.8819430161, 16.9115345253, 16.9410743461, 16.9705627485, 17.0000000000,
  17.0293863659, 17.0587221092, 17.0880074906, 17.1172427686, 17.1464281995,
  17.1755640373, 17.2046505341, 17.2336879396, 17.2626765016, 17.2916164658,
  17.3205080757, 17.3493515729, 17.3781471970, 17.4068951855, 17.4355957742,
  17.4642491966, 17.4928556845, 17.5214154679, 17.5499287748, 17.5783958312,
  17.6068168617, 17.6351920885, 17.6635217327, 17.6918060130, 17.7200451467,
  17.7482393493, 17.7763888346, 17.8044938148, 17.8325545001, 17.8605710995,
  17.8885438200, 17.9164728672, 17.9443584449, 17.9722007556, 18.0000000000,
  18.0277563773, 18.0554700853, 18.0831413200, 18.1107702763, 18.1383571472,
  18.1659021246, 18.1934053987, 18.2208671583, 18.2482875909, 18.2756668825,
  18.3030052177, 18.3303027798, 18.3575597507, 18.3847763109, 18.4119526395,
  18.4390889146, 18.4661853126, 18.4932420089, 18.5202591775, 18.5472369910,
  18.5741756210, 18.6010752377, 18.6279360102, 18.6547581062, 18.6815416923,
  18.7082869339, 18.7349939952, 18.7616630393, 18.7882942281, 18.8148877222,
  18.8414436814, 18.8679622641, 18.8944436277, 18.9208879284, 18.9472953215,
  18.9736659610, 19.0000000000, 19.0262975904, 19.0525588833, 19.0787840283,
  19.1049731745, 19.1311264697, 19.1572440607, 19.1833260933, 19.2093727123,
  19.2353840617, 19.2613602843, 19.2873015220, 19.3132079158, 19.3390796058,
  19.3649167310, 19.3907194297, 19.4164878389, 19.4422220952, 19.4679223339,
  19.4935886896, 19.5192212959, 19.5448202857, 19.5703857908, 19.5959179423,
  19.6214168703, 19.6468827044, 19.6723155729, 19.6977156036, 19.7230829233,
  19.7484176581, 19.7737199333, 19.7989898732, 19.8242276016, 19.8494332413,
  19.8746069144, 19.8997487421, 19.9248588452, 19.9499373433, 19.9749843554,
  20.0000000000, 20.0249843945, 20.0499376558, 20.0748598999, 20.0997512422,
  20.1246117975, 20.1494416796, 20.1742410018, 20.1990098767, 20.2237484162,
  20.2484567313, 20.2731349327, 20.2977831302, 20.3224014329, 20.3469899494,
  20.3715487875, 20.3960780544, 20.4205778567, 20.4450483003, 20.4694894905,
  20.4939015319, 20.5182845287, 20.5426385842, 20.5669638012, 20.5912602820,
  20.6155281281, 20.6397674406, 20.6639783198, 20.6881608656, 20.7123151772,
  20.7364413533, 20.7605394920, 20.7846096908, 20.8086520467, 20.8326666560,
  20.8566536146, 20.8806130178, 20.9045449604, 20.9284495365, 20.9523268398,
  20.9761769634, 21.0000000000, 21.0237960416, 21.0475651798, 21.0713075057,
  21.0950231097, 21.1187120819, 21.1423745119, 21.1660104885, 21.1896201004,
  21.2132034356, 21.2367605816, 21.2602916255, 21.2837966538, 21.3072757527,
  21.3307290077, 21.3541565041, 21.3775583264, 21.4009345590, 21.4242852856,
  21.4476105895, 21.4709105536, 21.4941852602, 21.5174347914, 21.5406592285,
  21.5638586528, 21.5870331449, 21.6101827850, 21.6333076528, 21.6564078277,
  21.6794833887, 21.7025344142, 21.7255609824, 21.7485631709, 21.7715410571,
  21.7944947177, 21.8174242293, 21.8403296678, 21.8632111091, 21.8860686282,
  21.9089023002, 21.9317121995, 21.9544984001, 21.9772609758, 22.0000000000,
  22.0227155455, 22.0454076850, 22.0680764907, 22.0907220344, 22.1133443875,
  22.1359436212, 22.1585198062, 22.1810730128, 22.2036033112, 22.2261107709,
  22.2485954613, 22.2710574513, 22.2934968096, 22.3159136044, 22.3383079037,
  22.3606797750, 22.3830292856, 22.4053565024, 22.4276614920, 22.4499443206,
  22.4722050542, 22.4944437584, 22.5166604984, 22.5388553392, 22.5610283454,
  22.5831795813, 22.6053091109, 22.6274169980, 22.6495033058, 22.6715680975,
  22.6936114358, 22.7156333832, 22.7376340018, 22.7596133535, 22.7815714998,
  22.8035085020, 22.8254244210, 22.8473193176, 22.8691932521, 22.8910462845,
  22.9128784748, 22.9346898824, 22.9564805665, 22.9782505862, 23.0000000000,
  23.0217288664, 23.0434372436, 23.0651251893, 23.0867927612, 23.1084400166,
  23.1300670124, 23.1516738056, 23.1732604525, 23.1948270095, 23.2163735325,
  23.2379000772, 23.2594066992, 23.2808934536, 23.3023603955, 23.3238075794,
  23.3452350599, 23.3666428911, 23.3880311271, 23.4093998214, 23.4307490277,
  23.4520787991, 23.4733891886, 23.4946802489, 23.5159520326, 23.5372045919,
  23.5584379788, 23.5796522451, 23.6008474424, 23.6220236220, 23.6431808351,
  23.6643191324, 23.6854385647, 23.7065391823, 23.7276210354, 23.7486841741,
  23.7697286480, 23.7907545067, 23.8117617996, 23.8327505756, 23.8537208838,
  23.8746727726, 23.8956062907, 23.9165214862, 23.9374184072, 23.9582971014,
  23.9791576166, 24.0000000000, 24.0208242989, 24.0416305603, 24.0624188310,
  24.0831891576, 24.1039415864, 24.1246761636, 24.1453929353, 24.1660919472,
  24.1867732449, 24.2074368738, 24.2280828792, 24.2487113060, 24.2693221990,
  24.2899156030, 24.3104915623, 24.3310501212, 24.3515913238, 24.3721152139,
  24.3926218353, 24.4131112315, 24.4335834457, 24.4540385213, 24.4744765010,
  24.4948974278, 24.5153013443, 24.5356882928, 24.5560583156, 24.5764114549,
  24.5967477525, 24.6170672502, 24.6373699895, 24.6576560119, 24.6779253585,
  24.6981780705, 24.7184141886, 24.7386337537, 24.7588368063, 24.7790233867,
  24.7991935353, 24.8193472920, 24.8394846967, 24.8596057893, 24.8797106092,
  24.8997991960, 24.9198715888, 24.9399278267, 24.9599679487, 24.9799919936,
  25.0000000000, 25.0199920064, 25.0399680511, 25.0599281723, 25.0798724080,
  25.0998007960, 25.1197133742, 25.1396101800, 25.1594912508, 25.1793566240,
  25.1992063367, 25.2190404258, 25.2388589282, 25.2586618806, 25.2784493195,
  25.2982212813, 25.3179778023, 25.3377189186, 25.3574446662, 25.3771550809,
  25.3968501984, 25.4165300543, 25.4361946840, 25.4558441227, 25.4754784057,
  25.4950975680, 25.5147016443, 25.5342906696, 25.5538646784, 25.5734237051,
  25.5929677841, 25.6124969497, 25.6320112360, 25.6515106768, 25.6709953060,
  25.6904651573, 25.7099202644, 25.7293606605, 25.7487863792, 25.7681974535,
  25.7875939165, 25.8069758011, 25.8263431403, 25.8456959666, 25.8650343128,
  25.8843582111, 25.9036676940, 25.9229627936, 25.9422435421, 25.9615099715,
  25.9807621135, 26.0000000000, 26.0192236625, 26.0384331326, 26.0576284416,
  26.0768096208, 26.0959767014, 26.1151297144, 26.1342686907, 26.1533936612,
  26.1725046566, 26.1916017074, 26.2106848442, 26.2297540972, 26.2488094968,
  26.2678510731, 26.2868788562, 26.3058928759, 26.3248931622, 26.3438797446,
  26.3628526529, 26.3818119165, 26.4007575649, 26.4196896272, 26.4386081328,
  26.4575131106, 26.4764045897, 26.4952825990, 26.5141471671, 26.5329983228,
  26.5518360947, 26.5706605112, 26.5894716006, 26.6082693913, 26.6270539114,
  26.6458251889, 26.6645832519, 26.6833281283, 26.7020598456, 26.7207784318,
  26.7394839142, 26.7581763205, 26.7768556780, 26.7955220139, 26.8141753556,
  26.8328157300, 26.8514431642, 26.8700576851, 26.8886593195, 26.9072480941,
  26.9258240357, 26.9443871706, 26.9629375254, 26.9814751265, 27.0000000000,
  27.0185121722, 27.0370116692, 27.0554985169, 27.0739727414, 27.0924343683,
  27.1108834235, 27.1293199325, 27.1477439210, 27.1661554144, 27.1845544381,
  27.2029410175, 27.2213151776, 27.2396769438, 27.2580263409, 27.2763633940,
  27.2946881279, 27.3130005675, 27.3313007374, 27.3495886624, 27.3678643668,
  27.3861278753, 27.4043792121, 27.4226184016, 27.4408454680, 27.4590604355,
  27.4772633281, 27.4954541697, 27.5136329844, 27.5317997959, 27.5499546279,
  27.5680975042, 27.5862284483, 27.6043474837, 27.6224546339, 27.6405499222,
  27.6586333719, 27.6767050062, 27.6947648483, 27.7128129211, 27.7308492477,
  27.7488738510, 27.7668867538, 27.7848879789, 27.8028775489, 27.8208554865,
  27.8388218142, 27.8567765544, 27.8747197295, 27.8926513620, 27.9105714739,
  27.9284800875, 27.9463772250, 27.9642629082, 27.9821371593, 28.0000000000,
  28.0178514522, 28.0356915378, 28.0535202782, 28.0713376952, 28.0891438104,
  28.1069386451, 28.1247222209, 28.1424945589, 28.1602556807, 28.1780056072,
  28.1957443597, 28.2134719593, 28.2311884270, 28.2488937837, 28.2665880502,
  28.2842712475, 28.3019433962, 28.3196045170, 28.3372546306, 28.3548937575,
  28.3725219182, 28.3901391332, 28.4077454227, 28.4253408071, 28.4429253067,
  28.4604989415, 28.4780617318, 28.4956136976, 28.5131548588, 28.5306852354,
  28.5482048472, 28.5657137142, 28.5832118559, 28.6006992922, 28.6181760425,
  28.6356421266, 28.6530975638, 28.6705423737, 28.6879765756, 28.7054001888,
  28.7228132327, 28.7402157264, 28.7576076891, 28.7749891399, 28.7923600978,
  28.8097205818, 28.8270706108, 28.8444102037, 28.8617393793, 28.8790581564,
  28.8963665536, 28.9136645896, 28.9309522830, 28.9482296523, 28.9654967159,
  28.9827534924, 29.0000000000, 29.0172362571, 29.0344622819, 29.0516780927,
  29.0688837075, 29.0860791445, 29.1032644217, 29.1204395571, 29.1376045687,
  29.1547594742, 29.1719042916, 29.1890390387, 29.2061637330, 29.2232783924,
  29.2403830344, 29.2574776767, 29.2745623366, 29.2916370318, 29.3087017795,
  29.3257565972, 29.3428015022, 29.3598365118, 29.3768616431, 29.3938769134,
  29.4108823397, 29.4278779391, 29.4448637287, 29.4618397253, 29.4788059460,
  29.4957624075, 29.5127091267, 29.5296461205, 29.5465734054, 29.5634909982,
  29.5803989155, 29.5972971739, 29.6141857899, 29.6310647801, 29.6479341607,
  29.6647939484, 29.6816441593, 29.6984848098, 29.7153159162, 29.7321374946,
  29.7489495613, 29.7657521323, 29.7825452237, 29.7993288515, 29.8161030318,
  29.8328677804, 29.8496231132, 29.8663690461, 29.8831055950, 29.8998327755,
  29.9165506033, 29.9332590942, 29.9499582637, 29.9666481275, 29.9833287011,
  30.0000000000, 30.0166620396, 30.0333148354, 30.0499584026, 30.0665927567,
  30.0832179130, 30.0998338866, 30.1164406928, 30.1330383466, 30.1496268634,
  30.1662062580, 30.1827765456, 30.1993377411, 30.2158898595, 30.2324329157,
  30.2489669245, 30.2654919008, 30.2820078595, 30.2985148151, 30.3150127824,
  30.3315017762, 30.3479818110, 30.3644529014, 30.3809150619, 30.3973683071,
  30.4138126515, 30.4302481094, 30.4466746953, 30.4630924235, 30.4795013083,
  30.4959013640, 30.5122926048, 30.5286750449, 30.5450486986, 30.5614135799,
  30.5777697028, 30.5941170816, 30.6104557300, 30.6267856622, 30.6431068921,
  30.6594194335, 30.6757233004, 30.6920185064, 30.7083050656, 30.7245829915,
  30.7408522979, 30.7571129985, 30.7733651069, 30.7896086367, 30.8058436015,
  30.8220700148, 30.8382878902, 30.8544972411, 30.8706980809, 30.8868904230,
  30.9030742807, 30.9192496675, 30.9354165965, 30.9515750811, 30.9677251344,
  30.9838667697, 31.0000000000, 31.0161248385, 31.0322412984, 31.0483493925,
  31.0644491340, 31.0805405358, 31.0966236109, 31.1126983722, 31.1287648325,
  31.1448230048, 31.1608729018, 31.1769145362, 31.1929479210, 31.2089730687,
  31.2249899920, 31.2409987036, 31.2569992162, 31.2729915422, 31.2889756943,
  31.3049516850, 31.3209195267, 31.3368792320, 31.3528308132, 31.3687742827,
  31.3847096530, 31.4006369362, 31.4165561448, 31.4324672910, 31.4483703870,
  31.4642654451, 31.4801524774, 31.4960314960, 31.5119025132, 31.5277655409,
  31.5436205912, 31.5594676761, 31.5753068077, 31.5911379979, 31.6069612586,

  /* ͼθ򤹤Τǡsqrt(1000)ޤɬ */
  31.6227766017,

  /* sqrt(1000)ޤǤǽʬΤsqrt(1001)ޤǽƤ */
  31.6385840391
};

double easy_sqrt(double x)
{
  double y;
  double a;

  a = 1.0;

  while (x >= 1000.0) { x *=   0.01; a *= 10.0; }
  while (x <    10.0) { x *= 100.0;  a *=  0.1; }
  while (x <   100.0) { x *=  10.0;  a *= (1.0/sqrt_value[10]); }

  y = sqrt_value[(int)(x + 0.5)] * a;

  return (y);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
